%V tomto programu jsou generovna jednorozmrn data z normlnho rozdlen,
%a je zkoumn vliv Masking a Swamping effectu 
%Na prvn a druhou verzi dat je aplikovna metoda implementovan v Matlabu - isoutlier();
%V tomto programu se zkoum poet dat n, pro kter je prmrn poet outliers detekovn sprvn

fclose all; close all; clear all; clc
NN = [1:200]; %vektor velikosti souboru
pocet_dat = size(NN,2);
outliers = [1,2,5,10]; %vektor poctu outliers (upper outliers)
rozmer_outliers = size(outliers,2);
pocet_simulaci = 1000; %pocet simulaci pro dan pocet outliers a velikost souboru
mu = 100;
sigma = 10;
alfa = 0.05;

upper_outliers=zeros(1,max(outliers));
lower_outlier=0;
%tabulky pro 1 lower outliers + k upper outliers pro rzn poet n
Grubbs_procentni_vysledek= zeros(pocet_dat,rozmer_outliers);% n X (pocet outliers+1)
Mean_procentni_vysledek =zeros(pocet_dat,rozmer_outliers);
Med_procentni_vysledek =zeros(pocet_dat,rozmer_outliers);
%tabulky pro k upper outliers pro rzn poet n
Grubbs_procentni_vysledek_upper= zeros(pocet_dat,rozmer_outliers);% n X (pocet outliers+1)
Mean_procentni_vysledek_upper =zeros(pocet_dat,rozmer_outliers);
Med_procentni_vysledek_upper =zeros(pocet_dat,rozmer_outliers);

for j = 1:pocet_dat %pres vsechny pocty dat
    for o = 1:rozmer_outliers %pres vsechny pocty outliers
         pocet_outliers_grubbs = 0; %inicializace
         pocet_outliers_mean = 0; %inicializace
         pocet_outliers_med = 0; %inicializace
          
         pocet_outliers_grubbs_upper = 0; %inicializace
         pocet_outliers_mean_upper = 0; %inicializace
         pocet_outliers_med_upper = 0; %inicializace
          
           for i = 1:pocet_simulaci
               norm_data = normrnd(mu,sigma,[1,NN(j)]); %data ridici se norm.r (pocet hodnot je promenlivy)
               maximum = max(norm_data);
               minimum = min(nonzeros(norm_data));
                 for outl = 1:(outliers(o)) % 1:1, 1:2, 1:5, 1:10        
upper_outliers(1,outl) =  maximum+4*sigma + rand*sigma; %generovani upper outliers pro dan pocty
                     end
          lower_outlier = minimum-4*sigma - rand*sigma; %1 lower outlier
data_obsahujici_outliers = [norm_data upper_outliers lower_outlier];
data_obsahujici_outliers_upper = [norm_data upper_outliers];
clear upper_outliers; clear lower_outlier; %aby se v i-t iteraci tvorila nova outliers

grubbs_test = sum(isoutlier(data_obsahujici_outliers, 'grubbs'));
mean_test=sum(isoutlier(data_obsahujici_outliers, 'mean'));
med_test=sum(isoutlier(data_obsahujici_outliers, 'median'));
  pocet_outliers_grubbs=pocet_outliers_grubbs+grubbs_test; 
  pocet_outliers_mean=pocet_outliers_mean+mean_test;
  pocet_outliers_med=pocet_outliers_med+med_test;
  
grubbs_test_upper = sum(isoutlier(data_obsahujici_outliers_upper, 'grubbs'));
mean_test_upper=sum(isoutlier(data_obsahujici_outliers_upper, 'mean'));
med_test_upper=sum(isoutlier(data_obsahujici_outliers_upper, 'median'));
  pocet_outliers_grubbs_upper=pocet_outliers_grubbs_upper+grubbs_test_upper;
  pocet_outliers_mean_upper=pocet_outliers_mean_upper+mean_test_upper;
  pocet_outliers_med_upper=pocet_outliers_med_upper+med_test_upper;
        end
           
Grubbs_procentni_vysledek(j,o) = pocet_outliers_grubbs/pocet_simulaci;
Mean_procentni_vysledek(j,o) = pocet_outliers_mean/pocet_simulaci;
Med_procentni_vysledek(j,o) = pocet_outliers_med/pocet_simulaci;
clear pocet_outliers_grubbs; clear pocet_outliers_mean; clear pocet_outliers_med;

Grubbs_procentni_vysledek_upper(j,o) = pocet_outliers_grubbs_upper/pocet_simulaci;
Mean_procentni_vysledek_upper(j,o) = pocet_outliers_mean_upper/pocet_simulaci;
Med_procentni_vysledek_upper(j,o) = pocet_outliers_med_upper/pocet_simulaci;
clear pocet_outliers_grubbs_upper; clear pocet_outliers_mean_upper; clear pocet_outliers_med_upper;
    end
end

  fig = figure(1);
for i = 1:rozmer_outliers
subplot(2,2,i)
plot((outliers(i)+2):pocet_dat,Grubbs_procentni_vysledek((outliers(i)+2):pocet_dat,i),'LineWidth',1.5);
hold on;
plot((outliers(i)+2):pocet_dat,Mean_procentni_vysledek((outliers(i)+2):pocet_dat,i),'LineWidth',1.5);
hold on;
plot((outliers(i)+2):pocet_dat,Med_procentni_vysledek((outliers(i)+2):pocet_dat,i),'LineWidth',1.5);
hold on;
yline(outliers(i)+1,'k','LineWidth',1.5);
title("Data obsahujc "+(outliers(i)+1)+" outliers");
legend('Grubbs test','Mean test','Median test','Location','southeast');
xlabel('Poet dat dch se normlnm rozdlenm N');
ylabel('Poet detekovanch outliers');
hold off;
end
sgtitle("Prmrn poet nalezench outliers pomoc test implementovanch v Matlabu v 1. verzi dat");

 fig = figure(2);
for i = 1:rozmer_outliers
subplot(2,2,i)
plot((outliers(i)+1):pocet_dat,Grubbs_procentni_vysledek_upper((outliers(i)+1):pocet_dat,i),'LineWidth',1.5);
hold on;
plot((outliers(i)+1):pocet_dat,Mean_procentni_vysledek_upper((outliers(i)+1):pocet_dat,i),'LineWidth',1.5);
hold on;
plot((outliers(i)+1):pocet_dat,Med_procentni_vysledek_upper((outliers(i)+1):pocet_dat,i),'LineWidth',1.5);
hold on;
yline(outliers(i),'k','LineWidth',1.5);
title("Data obsahujc "+outliers(i)+" outliers");
legend('Grubbs test','Mean test','Median test','Location','southeast');
xlabel('Poet dat dch se normlnm rozdlenm N');
ylabel('Poet detekovanch outliers');
hold off;
end
sgtitle("Prmrn poet nalezench outliers pomoc test implementovanch v Matlabu v 2. verzi dat");

vysledky = zeros(3,4);
vysledky_upper = zeros(3,4);
for i = 1 :rozmer_outliers
    vysledky(1,i) = find((outliers(i)+1)<=Grubbs_procentni_vysledek((outliers(i)+2):pocet_dat,i), 1, 'first');
    vysledky(2,i) = find((outliers(i)+1)<=Mean_procentni_vysledek((outliers(i)+2):pocet_dat,i), 1, 'first');
    vysledky(3,i) = find((outliers(i)+1)<=Med_procentni_vysledek((outliers(i)+2):pocet_dat,i), 1, 'first');
end

  for i = 1:rozmer_outliers  
vysledky_upper(1,i) = find(outliers(i)<=Grubbs_procentni_vysledek_upper((outliers(i)+1):pocet_dat,i), 1, 'first');
    vysledky_upper(2,i) = find(outliers(i)<=Mean_procentni_vysledek_upper((outliers(i)+1):pocet_dat,i), 1, 'first');
    vysledky_upper(3,i) = find(outliers(i)<=Med_procentni_vysledek_upper((outliers(i)+1):pocet_dat,i), 1, 'first');
  end
  
  
vysledek = array2table(vysledky, 'VariableNames',{'1 lower outlier, 1 upper outlier','1 lower outlier, 2 upper outlier','1 lower outlier, 5 upper outliers','1 lower outlier, 10 upper outliers'},'RowNames',{'Grubbs test','Mean test','Median test'});
vysledek1 = table(vysledek,'VariableNames',{'Poet dat N, kdy je prmrn poet outliers detekovn sprvn'});
display(vysledek1)

vysledek_upper = array2table(vysledky_upper, 'VariableNames',{'1 upper outlier','2 upper outlier','5 upper outliers','10 upper outliers'},'RowNames',{'Grubbs test','Mean test','Median test'});
vysledek1_upper = table(vysledek_upper,'VariableNames',{'Poet dat N, kdy je prmrn poet outliers detekovn sprvn'});
display(vysledek1_upper)