%V tomto programu jsou generovna jednorozmrn data z normlnho rozdlen,
%a je zkoumn vliv Masking a Swamping effectu
%Na prvn a druhou verzi dat je aplikovan run implementovan metoda Grubbsova testu a metoda implementovan v Matlabu isoutlier(Grubbs)
fclose all; close all; clear all; clc
NN = [5,10,30,50,100]; %vektor velikosti souboru N
pocet_dat = size(NN,2);
outliers = [1,2,5,10]; %vektor poctu outliers (upper outliers)
rozmer_outliers = size(outliers,2);
pocet_simulaci = 1000; %pocet simulaci pro dan pocet outliers a velikost souboru
mu = 100;
sigma = 10;
alfa = 0.05;

upper_outliers=zeros(1,max(outliers));
lower_outlier = 0;
%tabulky pro 1 lower outliers + k upper outliers pro rzn poet n
Grubbs_procentni_vysledek_x1 = zeros(pocet_dat,rozmer_outliers);% n X (pocet outliers+1)
Grubbs_procentni_vysledek_xn = zeros(pocet_dat,rozmer_outliers);
Grubbs_Matlab_procentni_vysledek_x1 = zeros(pocet_dat,rozmer_outliers);
Grubbs_Matlab_procentni_vysledek_xn = zeros(pocet_dat,rozmer_outliers);
%tabulky pro k upper outliers pro rzn poet n
Grubbs_procentni_vysledek_x1_upper = zeros(pocet_dat,rozmer_outliers);% n X pocet outliers 
Grubbs_procentni_vysledek_xn_upper = zeros(pocet_dat,rozmer_outliers);
Grubbs_Matlab_procentni_vysledek_x1_upper = zeros(pocet_dat,rozmer_outliers);
Grubbs_Matlab_procentni_vysledek_xn_upper = zeros(pocet_dat,rozmer_outliers);

for j = 1:pocet_dat %pres vsechny pocty dat
    for o = 1:rozmer_outliers %pres vsechny pocty outliers
         suma_prijmutiH1_1 = 0; %inicializace
         suma_prijmutiH1_n = 0; %inicializace
         suma_prijmutiH1_1_matlab = 0; %inicializace
         suma_prijmutiH1_n_matlab = 0; %inicializace
         
         suma_prijmutiH1_1_upper = 0; %inicializace
         suma_prijmutiH1_n_upper = 0; %inicializace
         suma_prijmutiH1_1_matlab_upper = 0; %inicializace
         suma_prijmutiH1_n_matlab_upper = 0; %inicializace
         
            for i = 1:pocet_simulaci
               norm_data = normrnd(mu,sigma,[1,NN(j)]); %data ridici se norm.r (pocet hodnot je promenlivy)
               maximum = max(norm_data);
               minimum = min(nonzeros(norm_data));
                 for outl = 1:(outliers(o)) % 1:1, 1:2, 1:5, 1:10        
            upper_outliers(1,outl) =  maximum+4*sigma + rand*sigma; %generovani upper outliers pro dan pocty
                 end
      lower_outlier = minimum-4*sigma - rand*sigma; %1 lower outlier
      data_obsahujici_outliers_upper = [norm_data upper_outliers]; %jen upper outliers
      data_obsahujici_outliers = [norm_data upper_outliers lower_outlier];

n = nnz(data_obsahujici_outliers); %=pocet dat celkem = n+outliers
nn = nnz(data_obsahujici_outliers_upper); %=pocet dat celkem = n+outliers

if (i == 1)
    f = figure(j);
    subplot(2,2,o);
    plot(1, lower_outlier,'o', 'MarkerFaceColor', 'r');
    hold on;
    plot(2:NN(j)+1,sort(norm_data),'o','MarkerFaceColor', 'b');
    hold on;
    if (outliers(o) == 1)
        plot(NN(j)+2,upper_outliers(1),'o', 'MarkerFaceColor', 'r');
    else
    plot(NN(j)+2:NN(j)+1+outliers(o),sort(upper_outliers),'o', 'MarkerFaceColor', 'r');
    end
    yline(100);
    yline(100+3*sigma);
    yline(100-3*sigma);
    yticks([50 100-3*sigma 100 100+3*sigma 150])
    hold off;
title("Poet lower outliers: 1, poet upper outliers:" + outliers(o));
xlabel('Celkov poet dat n');
ylabel('Hodnota pozorovn');
sgtitle("Poet dat N=" + NN(j));
end

if (i == 1)
    f = figure(j+5);
    subplot(2,2,o);
    plot(1:NN(j),sort(norm_data),'o', 'MarkerFaceColor', 'b');
    hold on;
    if (outliers(o) == 1)
        plot(NN(j)+1,upper_outliers(1),'o', 'MarkerFaceColor', 'r');
    else
    plot(NN(j)+1:NN(j)+outliers(o),sort(upper_outliers),'o', 'MarkerFaceColor', 'r');
    end    
    yline(100);
    yline(100+3*sigma);
    yline(100-3*sigma);
    yticks([50 100-3*sigma 100 100+3*sigma 150])
    hold off;
title("Poet upper outliers:" + outliers(o));
xlabel('Celkov poet dat n');
ylabel('Hodnota pozorovn');
sgtitle("Poet dat N=" + NN(j));
end
clear upper_outliers; clear lower_outlier; %aby se v i-t iteraci tvorila nova outliers

prumer = mean(nonzeros(data_obsahujici_outliers));
s = std(nonzeros(data_obsahujici_outliers));

prumer_upper = mean(nonzeros(data_obsahujici_outliers_upper));
s_upper = std(nonzeros(data_obsahujici_outliers_upper));

T1 = (prumer - min(nonzeros(data_obsahujici_outliers)))/s;
Tn = (max(nonzeros(data_obsahujici_outliers))-prumer)/s;
T_alfa = (n-1)/sqrt(n)*sqrt(((tinv(alfa/n,n-2)^2))/(n-2+(tinv(alfa/n,n-2)^2)));%vychazi viz tabulky kritickych hodnot Barnett, str 298 pro 5%

T1_upper = (prumer_upper - min(nonzeros(data_obsahujici_outliers_upper)))/s_upper;
Tn_upper = (max(nonzeros(data_obsahujici_outliers_upper))-prumer_upper)/s_upper;
T_alfa_upper = (nn-1)/sqrt(nn)*sqrt(((tinv(alfa/nn,nn-2)^2))/(nn-2+(tinv(alfa/nn,nn-2)^2))); 

grubbs_test_matlab = (isoutlier(sort(data_obsahujici_outliers), 'grubbs'));
suma_prijmutiH1_1_matlab=suma_prijmutiH1_1_matlab+grubbs_test_matlab(1,1); %x1 je outlier
suma_prijmutiH1_n_matlab=suma_prijmutiH1_n_matlab+grubbs_test_matlab(1,n); %xn je outlier

grubbs_test_matlab_upper = (isoutlier(sort(data_obsahujici_outliers_upper), 'grubbs'));
suma_prijmutiH1_1_matlab_upper=suma_prijmutiH1_1_matlab_upper+grubbs_test_matlab_upper(1,1); %x1 je outlier
suma_prijmutiH1_n_matlab_upper=suma_prijmutiH1_n_matlab_upper+grubbs_test_matlab_upper(1,nn); %xn je outlier

if( T1>T_alfa)  
    suma_prijmutiH1_1=suma_prijmutiH1_1+1;
end
if( Tn>T_alfa)  
suma_prijmutiH1_n=suma_prijmutiH1_n+1;
end

if( T1_upper>T_alfa_upper)  
    suma_prijmutiH1_1_upper=suma_prijmutiH1_1_upper+1;
end
if( Tn_upper>T_alfa_upper)  
suma_prijmutiH1_n_upper=suma_prijmutiH1_n_upper+1;
end
        end
           
Grubbs_procentni_vysledek_x1(j,o) = suma_prijmutiH1_1/pocet_simulaci;
Grubbs_procentni_vysledek_xn(j,o)= suma_prijmutiH1_n/pocet_simulaci;
clear suma_prijmutiH1_n, clear suma_prijmutiH1_1;
Grubbs_Matlab_procentni_vysledek_x1(j,o)= suma_prijmutiH1_1_matlab/pocet_simulaci;
Grubbs_Matlab_procentni_vysledek_xn(j,o)= suma_prijmutiH1_n_matlab/pocet_simulaci;
clear suma_prijmutiH1_1_matlab; clear suma_prijmutiH1_n_matlab;

Grubbs_procentni_vysledek_x1_upper(j,o) = suma_prijmutiH1_1_upper/pocet_simulaci;
Grubbs_procentni_vysledek_xn_upper(j,o)= suma_prijmutiH1_n_upper/pocet_simulaci;
clear suma_prijmutiH1_n_upper, clear suma_prijmutiH1_1_upper;
Grubbs_Matlab_procentni_vysledek_x1_upper(j,o)= suma_prijmutiH1_1_matlab_upper/pocet_simulaci;
Grubbs_Matlab_procentni_vysledek_xn_upper(j,o)= suma_prijmutiH1_n_matlab_upper/pocet_simulaci;
clear suma_prijmutiH1_1_matlab_upper; clear suma_prijmutiH1_n_matlab_upper;
    end
end
   Grubbs_procentni_vysledek_x1(1,3)=NaN; %nem smysl testovat - vetsi (i rovno) pocet outliers, nez vygenerovanych dat
   Grubbs_procentni_vysledek_x1(1,4)=NaN;
   Grubbs_procentni_vysledek_x1(2,4)=NaN;
   Grubbs_procentni_vysledek_xn(1,3)=NaN;
   Grubbs_procentni_vysledek_xn(1,4)=NaN;
   Grubbs_procentni_vysledek_xn(2,4)=NaN;
    
   Grubbs_Matlab_procentni_vysledek_x1(1,3)=NaN;
   Grubbs_Matlab_procentni_vysledek_x1(1,4)=NaN;
   Grubbs_Matlab_procentni_vysledek_x1(2,4)=NaN;
   Grubbs_Matlab_procentni_vysledek_xn(1,3)=NaN;
   Grubbs_Matlab_procentni_vysledek_xn(1,4)=NaN;
   Grubbs_Matlab_procentni_vysledek_xn(2,4)=NaN;
    
vysledek_x1_1 = array2table(Grubbs_procentni_vysledek_x1, 'VariableNames',{'1 lower outlier, 1 upper outlier','1 lower outlier, 2 upper outlier','1 lower outlier, 5 upper outliers','1 lower outlier, 10 upper outliers'},'RowNames',{'N=5','N=10','N=30','N=50','N=100'});
vysledek_x1_11 = table(vysledek_x1_1,'VariableNames',{'spnost Grubbsova testu pro detekci outliera x1'});
display(vysledek_x1_11)

vysledek_x1_2 = array2table(Grubbs_Matlab_procentni_vysledek_x1, 'VariableNames',{'1 lower outlier, 1 upper outlier','1 lower outlier, 2 upper outlier','1 lower outlier, 5 upper outliers','1 lower outlier, 10 upper outliers'},'RowNames',{'N=5','N=10','N=30','N=50','N=100'});
vysledek_x1_22 = table(vysledek_x1_2,'VariableNames',{'spnost Grubbsova testu (Matlab) pro detekci outliera x1'});
display(vysledek_x1_22)


vysledek_xn_1 = array2table(Grubbs_procentni_vysledek_xn, 'VariableNames',{'1 lower outlier, 1 upper outlier','1 lower outlier, 2 upper outlier','1 lower outlier, 5 upper outliers','1 lower outlier, 10 upper outliers'},'RowNames',{'n=5','n=10','n=30','n=50','n=100'});
vysledek_xn_11 = table(vysledek_xn_1,'VariableNames',{'spnost Grubbsova testu pro detekci outliera xn'});
display(vysledek_xn_11)

vysledek_xn_2 = array2table(Grubbs_Matlab_procentni_vysledek_xn, 'VariableNames',{'1 lower outlier, 1 upper outlier','1 lower outlier, 2 upper outlier','1 lower outlier, 5 upper outliers','1 lower outlier, 10 upper outliers'},'RowNames',{'n=5','n=10','n=30','n=50','n=100'});
vysledek_xn_22 = table(vysledek_xn_2,'VariableNames',{'spnost Grubbsova testu (Matlab) pro detekci outliera xn'});
display(vysledek_xn_22)


Grubbs_procentni_vysledek_x1_upper(1,3)=NaN; %nem smysl testovat - vetsi (i rovno) pocet outliers, nez vygenerovanych dat
Grubbs_procentni_vysledek_x1_upper(1,4)=NaN;
Grubbs_procentni_vysledek_x1_upper(2,4)=NaN;
Grubbs_procentni_vysledek_xn_upper(1,3)=NaN;
Grubbs_procentni_vysledek_xn_upper(1,4)=NaN;
Grubbs_procentni_vysledek_xn_upper(2,4)=NaN;
    
Grubbs_Matlab_procentni_vysledek_x1_upper(1,3)=NaN;
Grubbs_Matlab_procentni_vysledek_x1_upper(1,4)=NaN;
Grubbs_Matlab_procentni_vysledek_x1_upper(2,4)=NaN;
Grubbs_Matlab_procentni_vysledek_xn_upper(1,3)=NaN;
Grubbs_Matlab_procentni_vysledek_xn_upper(1,4)=NaN;
Grubbs_Matlab_procentni_vysledek_xn_upper(2,4)=NaN;
    
vysledek_x1_1_upper = array2table(Grubbs_procentni_vysledek_x1_upper, 'VariableNames',{'1 upper outlier','2 upper outlier','5 upper outliers','10 upper outliers'},'RowNames',{'N=5','N=10','N=30','N=50','N=100'});
vysledek_x1_11_upper = table(vysledek_x1_1_upper,'VariableNames',{'spnost Grubbsova testu pro detekci outliera x1'});
display(vysledek_x1_11_upper)

vysledek_x1_2_upper = array2table(Grubbs_Matlab_procentni_vysledek_x1_upper, 'VariableNames',{'1 upper outlier','2 upper outlier','5 upper outliers','10 upper outliers'},'RowNames',{'N=5','N=10','N=30','N=50','N=100'});
vysledek_x1_22_upper = table(vysledek_x1_2_upper,'VariableNames',{'spnost Grubbsova testu (Matlab) pro detekci outliera x1'});
display(vysledek_x1_22_upper)

vysledek_xn_1_upper = array2table(Grubbs_procentni_vysledek_xn_upper, 'VariableNames',{'1 upper outlier','2 upper outlier','5 upper outliers','10 upper outliers'},'RowNames',{'N=5','N=10','N=30','N=50','N=100'});
vysledek_xn_11_upper = table(vysledek_xn_1_upper,'VariableNames',{'spnost Grubbsova testu pro detekci outliera xn'});
display(vysledek_xn_11_upper)

vysledek_xn_2_upper = array2table(Grubbs_Matlab_procentni_vysledek_xn_upper, 'VariableNames',{'1 upper outlier','2 upper outlier','5 upper outliers','10 upper outliers'},'RowNames',{'N=5','N=10','N=30','N=50','N=100'});
vysledek_xn_22_upper = table(vysledek_xn_2_upper,'VariableNames',{'spnost Grubbsova testu (Matlab) pro detekci outliera xn'});
display(vysledek_xn_22_upper)