%V tomto programu jsou generovna jednorozmrn data z normlnho rozdlen, a je zkoumno, zda
%Grubbsv test (run implementovan a implementovan v Matlabu) objev
%"falen" odlehl pozorovn
fclose all; close all; clear all; clc
NN = [5,10,30,50,100]; %vektor velikosti souboru N = n zde
pocet_dat = size(NN,2);
pocet_simulaci = 1000; %pocet simulaci pro dan pocet outliers a velikost souboru
mu = 100;
sigma = 10;
alfa = 0.05;

Grubbs_procentni_vysledek_x1 = zeros(pocet_dat,1);
Grubbs_procentni_vysledek_xn = zeros(pocet_dat,1);

Grubbs_Matlab_procentni_vysledek_x1 = zeros(pocet_dat,1);
Grubbs_Matlab_procentni_vysledek_xn = zeros(pocet_dat,1);

for j = 1:pocet_dat %pres vsechny pocty dat
         suma_prijmutiH1_1 = 0; %inicializace
         suma_prijmutiH1_n = 0; %inicializace
         
         suma_prijmutiH1_1_matlab = 0; %inicializace
         suma_prijmutiH1_n_matlab = 0; %inicializace
                      
           for i = 1:pocet_simulaci
               norm_data = normrnd(mu,sigma,[1,NN(j)]); %data ridici se norm.r (pocet hodnot je promenlivy)
               N = NN(j);
               serazena_data =sort(nonzeros(norm_data));
           
if (i == 1)
    f = figure(j);
      plot(1:N,serazena_data,'o','MarkerFaceColor', 'b');
    hold on;
yline(100);
yline(100+3*sigma);
yline(100-3*sigma);
yticks([50 100-3*sigma 100 100+3*sigma 150])
hold off; 
title("Poet dat n=N=" + NN(j));
xlabel('Celkov poet dat n');
ylabel('Hodnota pozorovn');
end

prumer = mean(nonzeros(norm_data));
s = std(nonzeros(norm_data));

T1 = (prumer - min(nonzeros(norm_data)))/s;
Tn = (max(nonzeros(norm_data))-prumer)/s;
T_alfa = (N-1)/sqrt(N)*sqrt(((tinv(alfa/N,N-2)^2))/(N-2+(tinv(alfa/N,N-2)^2)));%vychazi viz tabulky kritickych hodnot Barnett, str 298 pro 5%

grubbs_test_matlab = (isoutlier(sort(norm_data), 'grubbs')); 
suma_prijmutiH1_1_matlab=suma_prijmutiH1_1_matlab+grubbs_test_matlab(1,1); %x1 je outlier
suma_prijmutiH1_n_matlab=suma_prijmutiH1_n_matlab+grubbs_test_matlab(1,N); %xn je outlier

if( T1>T_alfa)  
    suma_prijmutiH1_1=suma_prijmutiH1_1+1;
end
if( Tn>T_alfa)  
suma_prijmutiH1_n=suma_prijmutiH1_n+1;
end
        end
           
Grubbs_procentni_vysledek_x1(j) = suma_prijmutiH1_1/pocet_simulaci;
Grubbs_procentni_vysledek_xn(j)= suma_prijmutiH1_n/pocet_simulaci;
clear suma_prijmutiH1_n, clear suma_prijmutiH1_1;
Grubbs_Matlab_procentni_vysledek_x1(j)= suma_prijmutiH1_1_matlab/pocet_simulaci;
Grubbs_Matlab_procentni_vysledek_xn(j)= suma_prijmutiH1_n_matlab/pocet_simulaci;
clear suma_prijmutiH1_1_matlab; clear suma_prijmutiH1_n_matlab;
    end
   
vysledek_x1_1 = array2table(Grubbs_procentni_vysledek_x1, 'VariableNames',{'Nalezen falenho outliera x1'},'RowNames',{'N=5','N=10','N=30','N=50','N=100'});
vysledek_x1_11 = table(vysledek_x1_1,'VariableNames',{'spnost Grubbsova testu pro x1'});
display(vysledek_x1_11)

vysledek_x1_2 = array2table(Grubbs_Matlab_procentni_vysledek_x1, 'VariableNames',{'Nalezen falenho outliera x1'},'RowNames',{'N=5','N=10','N=30','N=50','N=100'});
vysledek_x1_22 = table(vysledek_x1_2,'VariableNames',{'spnost Grubbsova testu (Matlab) pro x1'});
display(vysledek_x1_22)

vysledek_xn_1 = array2table(Grubbs_procentni_vysledek_xn, 'VariableNames',{'Nalezen falenho outliera xn'},'RowNames',{'N=5','N=10','N=30','N=50','N=100'});
vysledek_xn_11 = table(vysledek_xn_1,'VariableNames',{'spnost Grubbsova testu pro xn'});
display(vysledek_xn_11)

vysledek_xn_2 = array2table(Grubbs_Matlab_procentni_vysledek_xn, 'VariableNames',{'Nalezen falenho outliera xn'},'RowNames',{'N=5','N=10','N=30','N=50','N=100'});
vysledek_xn_22 = table(vysledek_xn_2,'VariableNames',{'spnost Grubbsova testu (Matlab) pro xn'});
display(vysledek_xn_22)